// Script assets have changed for v2.3.0 see
// https://help.yoyogames.com/hc/en-us/articles/360005277377 for more information
function scr_function_list(){

}


/*
hexgrid_init(length)

hexgrid_get_ind(x, y) : return pos[0]=hcell, pos[1]=vcell
hexgrid_get_pos(h, v) : return pos[0]=x, pos[1]=y snapped coord
hexgrid_repos_xy() : Set snapped position (x,y)

hexgrid_link_on(hcell,vcell)
hexgrid_link_exists(x,y,prio)
hexgrid_link_prio_pos(x,y,prio)

hexgrid_snap_free(x,y,obj,cell)
hexgrid_snap_place(x,y,obj,cell)
hexgrid_snap_meeting(x,y,obj,cell)
hexgrid_snap_place_priority(x,y,obj,cell,type)

hexgrid_snap_dist(x1,y1,x2,y2) : Get distance to point

hexgrid_set_path(x,y) : Create path

get_pos_str(str)

//----- camera script
init_camera_settings()
camera_following(x,y)

*/




//==================================================================
function init_camera_settings(){
///init_camera_settings()
var vw,vh;
vw=800;
vh=600;
view_enabled=1;
view_visible[0]=1;
camera_set_view_size(view_camera[0],vw,vh);
view_xport[0]=0;
view_yport[0]=0;
view_wport[0]=vw;
view_hport[0]=vh;

camera_set_view_border(view_camera[0],floor(vw/2),floor(vh/2));
camera_set_view_speed(view_camera[0],-1,-1);
}

//==================================================================


//==================================================================
function camera_following(_x,_y){
///camera_following(x,y)
///@param x
///@param y

var px,py,cam,vw,vh,cw,ch,cx,cy;
px=round(_x);
py=round(_y);

cam=view_camera[0];
vw=camera_get_view_width(cam);
vh=camera_get_view_height(cam);

cw=camera_get_view_border_x(cam);
ch=camera_get_view_border_y(cam);
cx=camera_get_view_x(cam);
cy=camera_get_view_y(cam);

camera_set_view_pos(cam,
clamp(clamp(cx,px-(vw-cw),px-cw),0,room_width-vw)
,
clamp(clamp(cy,py-(vh-ch),py-ch),0,room_height-vh)
);
}
//==================================================================






//==================================================================
function hexgrid_init(length){
/// hexgrid_init(length)
/// align h=0; v=1;
global.H_length = floor(length*0.5);
global.H_align = 0;
global.H_spacing = 1;
global.H_width = global.H_length*2;
global.H_half = global.H_width*0.5;
global.H_height = 1.5*global.H_length;
}
//==================================================================

//==================================================================
function hexgrid_get_ind(_x, _y){
/// hexgrid_get_ind(x, y)
///@param x
///@param y
/// return hcell, vcell
var divider, remainder, blank, xpos, xval, yval, indicator;

if global.H_align == 1 {
  temp = _x;
  _x = _y;
  _y = temp;
}

divider = _y div global.H_height;
remainder = _y mod global.H_height;
blank = global.H_half * (divider & 1 == global.H_spacing);

if remainder >= 0.5 * global.H_length {
  hpos = (_x - blank) div global.H_width;
  vpos = divider;
} else {
  xpos = _x - blank;
  xval = xpos mod global.H_half;
  yval = remainder;
  indicator = xpos div global.H_half;
  if indicator & 1 == 0 {
    if yval < 0.5 * global.H_length - 1 / sqrt(3) * xval {
      hpos = (indicator / 2) - (divider & 1 != global.H_spacing);
      vpos = divider - 1;
    } else {
      hpos = indicator / 2;
      vpos = divider;
    }
  } else {
    if yval < 1 / sqrt(3) * xval {
      hpos = floor(indicator / 2) + (divider & 1 == global.H_spacing);
      vpos = divider - 1;
    } else {
      hpos = floor(indicator / 2);
      vpos = divider;
    }
  }
}

if global.H_align == 1 {
  temp = hpos;
  hpos = vpos;
  vpos = temp;
}


pos[0]=hpos;
pos[1]=vpos;
}
//==================================================================


//==================================================================
function hexgrid_get_pos(h, v){
/// hexgrid_get_pos(h, v)
///@param hcell
///@param vcell

/// return snapped x,y coord
if global.H_align == 1 {
  temp = h;
  h = v;
  v = temp;
}

blank = global.H_half * (v & 1 == global.H_spacing);
xpos = blank + (h + 0.5) * global.H_width;
ypos = global.H_length + v * global.H_height;

if global.H_align == 1 {
  temp = xpos;
  xpos = ypos;
  ypos = temp;
}


pos[0]=xpos;
pos[1]=ypos;
}
//==================================================================



//==================================================================
function hexgrid_repos_xy(){
///hexgrid_repos_xy();
hexgrid_get_ind(x,y)
hexgrid_get_pos(pos[0],pos[1]);
x=pos[0];
y=pos[1];
}
//==================================================================



//==================================================================
function hexgrid_link_on(hcell,vcell){
///hexgrid_link_on(hcell,vcell)
///@param hcell
///@param vcell

var i,k,m,_hw,_hh,_px,_py,_cx,_cy,_x,_y,_w,_h,tp,n,m,_return,_d;
_x=hcell;
_y=vcell;


_hw=global.H_width;
_hh=global.H_width;


_return=0;

_px=_x;
_py=_y;
n=6;m=1;
//-----------------------------------
_px+=_hw;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;repeat(n){

if _px>0 && _py>0{
hexgrid_get_ind(_px,_py);
_cx=pos[0];
_cy=pos[0];
_d=ds_priority_find_priority(global.move_list_prio,string(_cx)+","+string(_cy));
if _d>=0{_return=1;break;}
}

if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

tp+=1;
}
//-----------------------------------

return _return;
}
//==================================================================



//==================================================================
function hexgrid_link_exists(_x,_y,_prio){
///hexgrid_link_exists(x,y,prio)
///@param x
///@param y
///@param prio

var i,k,m,_hw,_hh,_px,_py,_cx,_cy,_w,_h,tp,n,m,_return,_d;


_hw=global.H_width;
_hh=global.H_width;


_return=0;

_px=_x;
_py=_y;
n=6;m=1;
//-----------------------------------
_px+=_hw;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;repeat(6){

if _px>0 && _py>0{
hexgrid_get_ind(_px,_py);
_cx=pos[0];
_cy=pos[1];

_d=ds_priority_find_priority(global.move_list_prio,string(_cx)+","+string(_cy));
if _d==_prio{_return=1;break;}
}

if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

tp+=1;
}
//-----------------------------------


return _return;
}
//==================================================================



//==================================================================
function hexgrid_link_prio_pos(_x,_y,_prio){
///hexgrid_link_prio_pos(x,y,prio)
///@param x
///@param y
///@param prio

var i,k,m,_hw,_hh,_px,_py,_cx,_cy,_w,_h,tp,n,m,_return,_d;

_hw=global.H_width;
_hh=global.H_width;


_return=0;


pos[0]=_x;
pos[1]=_y;


_px=_x;
_py=_y;
//-----------------------------------
_px+=_hw;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;repeat(6){

if _px>0 && _py>0{
hexgrid_get_ind(_px,_py);
_cx=pos[0];
_cy=pos[1];

_d=ds_priority_find_priority(global.move_list_prio,string(_cx)+","+string(_cy));
if _d>0{
if (_d==(_prio)){
pos[0]=_px;
pos[1]=_py;
_return=1;
break;}
}}


if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

tp+=1;
}
//-----------------------------------

return _return;
}
//==================================================================



//==================================================================
function hexgrid_snap_free(_x,_y,obj,cell){
///hexgrid_snap_free(x,y,obj,cell)
///@param x
///@param y
///@param obj
///@param cell
var i,k,_hw,_hh,_px,_py,_cx,_cy,_w,_h,tp,n,m,_return,_cell_n;
_cell_n=cell;

_return=1;


//hex size
_hw=global.H_width;
_hh=global.H_width;

_px=_x;
_py=_y;
n=6;m=1;
i=0;repeat(_cell_n){
//-----------------------------------
_px+=_hw;_py=_y;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;k=0;repeat(n){

if position_meeting(_px,_py,obj){_return=0;break;}


if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

if (k+1) mod (floor(n/6))=0{if tp<5{tp+=1;}}

k+=1;}
//-----------------------------------
if _return==0{break;}
n+=6;
m+=1;
i+=1;}

return _return;
}
//==================================================================



//==================================================================
function hexgrid_snap_place(_x,_y,obj,cell){
///hexgrid_snap_place(x,y,obj,cell)
///@param x
///@param y
///@param obj
///@param cell
var i,k,m,_hw,_hh,_px,_py,_cx,_cy,_w,_h,tp,n,m,_return,_cell_n;

_cell_n=cell;

_return=noone;

var _cx,_cy;
//hex size
_hw=global.H_width;
_hh=global.H_width;

_px=_x;
_py=_y;
n=6;m=1;
i=0;repeat(_cell_n){
//-----------------------------------
_px+=_hw;_py=_y;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;k=0;repeat(n){

_return=instance_position(_px,_py,obj);
if instance_exists(_return){break;}

if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

if (k+1) mod (floor(n/6))=0{if tp<5{tp+=1;}}

k+=1;}
//-----------------------------------
if instance_exists(_return){break;}
n+=6;
m+=1;
i+=1;}

return _return;
}
//==================================================================



//==================================================================
function hexgrid_snap_meeting(_x,_y,obj,cell){
///hexgrid_snap_meeting(x,y,obj,cell)
///@param x
///@param y
///@param obj
///@param cell
var i,k,m,_hw,_hh,_px,_py,_cx,_cy,_w,_h,tp,n,m,_return,_cell_n;

_cell_n=cell;

_return=0;

var _cx,_cy;
//hex size
_hw=global.H_width;
_hh=global.H_width;

_px=_x;
_py=_y;
n=6;m=1;
i=0;repeat(_cell_n){
//-----------------------------------
_px+=_hw;_py=_y;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;k=0;repeat(n){

if position_meeting(_px,_py,obj){_return=1;break;}

if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

if (k+1) mod (floor(n/6))=0{if tp<5{tp+=1;}}

k+=1;}
//-----------------------------------
if _return>0{break;}
n+=6;
m+=1;
i+=1;}

return _return;
}
//==================================================================



//==================================================================
function hexgrid_snap_place_priority(_x,_y,obj,cell,type){
///hexgrid_snap_place_priority(x,y,obj,cell,type)
///@param x
///@param y
///@param obj
///@param cell
///@param type
//type : 0=hp 1=mp 2=level
var i,k,m,_hw,_hh,_px,_py,_cx,_cy,_w,_h,tp,n,m,_return,_cell_n;
_cell_n=cell;

_return=noone;

var _cx,_cy,it,_min,_max;
//hex size
_hw=global.H_width;
_hh=global.H_width;


_min=1000000;
_max=0;


_px=_x;
_py=_y;
n=6;m=1;
i=0;repeat(_cell_n){
//-----------------------------------
_px+=_hw;_py=_y;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);

tp=0;k=0;repeat(n){

//------------ Get instance
it=instance_position(_px,_py,obj);
if instance_exists(it){

if type<=0{if it.hp<=_min{_min=it.hp;_return=it;}}
if type==1{if it.mp<=_min{_min=it.mp;_return=it;}}

}
//------------ Get instance


if tp=0{_px-=_w;_py-=_h;}
if tp=1{_px-=_hw;}
if tp=2{_px-=_w;_py+=_h;}
if tp=3{_px+=_w;_py+=_h;}
if tp=4{_px+=_hw;}
if tp=5{_px+=_w;_py-=_h;}

if (k+1) mod (floor(n/6))=0{if tp<5{tp+=1;}}

k+=1;}
//-----------------------------------
n+=6;
m+=1;
i+=1;}

return _return;
}
//==================================================================




//==================================================================
function hexgrid_snap_dist(x1,y1,x2,y2){
///hexgrid_snap_dist(x1,y1,x2,y2)
var k,_hw,_hh,_w,_h;;


k=0;
if (x1>0 && y1>0 && x1<room_width && y1<room_height)
&& (x2>0 && y2>0 && x2<room_width && y2<room_height){


hexgrid_get_ind(x1,y1);
hexgrid_get_pos(pos[0],pos[1]);
x1=pos[0];y1=pos[1];
hexgrid_get_ind(x2,y2);
hexgrid_get_pos(pos[0],pos[1]);
x2=pos[0];y2=pos[1];


_hw=global.H_width;
_hh=global.H_width;

_w=_hw/2;
_h=(_hh/2)+((_hh/2)/2);


var xh,yh;
xh=max(1,floor(_hw/8));
yh=max(1,floor(_hh/8));


k=0;while(1){
if !(y2>(y1-yh) && y2<(y1+yh)){
if y2<y1{y2+=_h;}else{y2-=_h;}
if x2<x1{x2+=_w;}else{x2-=_w;}
}
else{
if !(x2>(x1-xh) && x2<(x1+xh)){
if x2<x1{x2+=_hw;}else{x2-=_hw;}
}
else{break;}
}

k+=1;}
}


return k;
}
//==================================================================


//==================================================================
function hexgrid_set_path(_x,_y){
///hexgrid_set_path(x,y)
///@param x
///@param y
var i,_px,_py,_gx,_gy,_cx,_cy,_return,_prio;


path_clear_points(global.move_path);


_return=0;

hexgrid_get_ind(_x,_y);
_cx=pos[0];
_cy=pos[1];
_prio=ds_priority_find_priority(global.move_list_prio,string(_cx)+","+string(_cy));

if _prio>0{
path_add_point(global.move_path,_x,_y,100);

_px=_x;
_py=_y;
for(i=_prio;i>1;i-=1;){
if hexgrid_link_prio_pos(_px,_py,i-1){
_px=pos[0];
_py=pos[1];
path_add_point(global.move_path,_px,_py,100);

}
}

path_reverse(global.move_path);

_return=path_get_number(global.move_path);
}
return _return;
}
//==================================================================

//==================================================================
function get_pos_str(str){
///get_pos_str(str)
var p;
str=string(str);

pos[0]=0;
pos[1]=0;

if string_count(",",str)==1{
p=string_pos(",",str);
if p>1{
pos[0]=real(string_copy(str,1,p-1));
pos[1]=real(string_delete(str,1,p));
}
}
}
//==================================================================





